//
// AMX Mod X SetAnimation Forward
// Copyright (C) Vincent Herbet (Arkshine)
//
// This software is licensed under the GNU General Public License, version 2.
// For full license details, see LICENSE file.
//

#include <amxxmodule.h>
#include <MemoryUtils.h>

namespace Utils
{
	void* FindAddressFromEntry(const char *entry, const char *library)
	{
		void* addressInBase = nullptr;
		void* finalAddress  = nullptr;

		if (strcmp(library, "mod") == 0)
		{
			addressInBase = reinterpret_cast<void*>(MDLL_Spawn);
		}
		else if (strcmp(library, "engine") == 0)
		{
			addressInBase = reinterpret_cast<void*>(gpGlobals);
		}

		if (*entry != '\\')
		{
			finalAddress = g_MemUtils.ResolveSymbolOfAddress(addressInBase, entry);
		}
		else
		{
			finalAddress = g_MemUtils.DecodeAndFindPattern(addressInBase, entry);
		}

		return finalAddress;
	}

	int PrivateToIndex(const void* pdata)
	{
		if (pdata)
		{
			char* ptr = const_cast<char*>(reinterpret_cast<const char*>(pdata));
			ptr += 4;

			entvars_t* pev = *(entvars_t**)ptr;

			if (pev && !FNullEnt(pev->pContainingEntity))
			{
				return ENTINDEX(pev->pContainingEntity);
			}
		}

		return 0;
	}
};
